Attribute VB_Name = "GoogleMap"
Option Explicit

' SiteMap nach Google Vorgaben
' https://www.google.com/webmasters/sitemaps/docs/en/protocol.html

'<?xml version="1.0" encoding="UTF-8"?>
'<urlset xmlns="http://www.google.com/schemas/sitemap/0.84">
'   <url>
'      <loc>http://www.yoursite.com/</loc>
'      <lastmod>2005-01-01</lastmod>
'      <changefreq>monthly</changefreq>
'      <priority>0.8</priority>
'   </url>
'   <url>
'      <loc>http://www.yoursite.com/catalog?item=12&amp;desc=vacation_hawaii</loc>
'      <changefreq>weekly</changefreq>
'   </url>
'   <url>
'      <loc>http://www.yoursite.com/catalog?item=73&amp;desc=vacation_new_zealand</loc>
'      <lastmod>2004-12-23</lastmod>
'      <changefreq>weekly</changefreq>
'   </url>
'   <url>
'      <loc>http://www.yoursite.com/catalog?item=74&amp;desc=vacation_newfoundland</loc>
'      <lastmod>2004-12-23T18:00:15+00:00</lastmod>
'      <priority>0.3</priority>
'   </url>
'   <url>
'      <loc>http://www.yoursite.com/catalog?item=83&amp;desc=vacation_usa</loc>
'      <lastmod>2004-11-23</lastmod>
'   </url>
'</urlset>

Sub GoogleMap()
    
    Dim count
    Dim wf As WebFile
    Dim str_xml As String
    Dim filegooglemap                     'Filehandle
    Dim objfso                         'FileSystemObject
    Dim inttotaladd, inttotalskip
        
'    Const gbaseURL As String = "http://www.msxfaq.de"
'    Const ggooglemapgsitemapfile As String = "C:/Inetpub/wwwroot/www.msxfaq.de/sitemap.xml"
'    Const ggooglemapns As String = "http://www.google.com/schemas/sitemap/0.84"

    Dim modifieddate
    Dim doc As New MSXML2.DOMDocument50
    Dim urlset As MSXML2.IXMLDOMElement
    Dim nn As NavigationNode
    
    Call Logging(0, "Googlemap: gestartet")
  
    Set urlset = doc.createNode(NODE_ELEMENT, "urlset", ggooglemapns)
    doc.appendChild urlset
    
    inttotaladd = 0
    inttotalskip = 0

    For Each nn In ActiveWeb.AllNavigationNodes
        Call Logging(5, "Googlemap: Progress File:" & nn.url)
        If nn.InNavBars = True Then
            Call Logging(4, "Googlemap:   Adding :" & nn.Label)
            inttotaladd = inttotaladd + 1
            Dim url As MSXML2.IXMLDOMElement
            Set url = doc.createNode(NODE_ELEMENT, "url", ggooglemapns)
            urlset.appendChild url
                    'URL addieren aber ohne kanonische URLs siehe http://schneegans.de/tips/kanonische-adressen
            Dim loc As MSXML2.IXMLDOMElement
            Set loc = doc.createNode(NODE_ELEMENT, "loc", ggooglemapns)
            loc.Text = gbaseURL & "/" & Replace(MakeRel(ActiveWeb.url & "/", nn.url), "index.htm", "", 1, -1, vbTextCompare)
            url.appendChild loc
            
            Dim lastmod As MSXML2.IXMLDOMElement
            Set lastmod = doc.createNode(NODE_ELEMENT, "lastmod", ggooglemapns)
            modifieddate = FormatDateTime(nn.file.Properties("vti_timelastmodified"), vbShortDate)
            lastmod.Text = Year(modifieddate) & "-" & Month(modifieddate) & "-" & Day(modifieddate)
            url.appendChild lastmod
        Else
            Call Logging(3, "Googlemap:   Skip File - Not in NavBar:" & nn.Label)
            inttotalskip = inttotalskip + 1
        End If
    Next

    doc.Save ActiveWeb & "/" & ggooglemapgsitemapfile
    
    Dim pwRss As PageWindowEx                                               'XML schn reformatieren
    Set pwRss = ActiveWeb.LocatePage(ggooglemapgsitemapfile)
    CommandBars.FindControl(ID:=9250).Execute
    pwRss.Save
    pwRss.Close
    
    Call Logging(0, "Googlemap: beendet  Add:" & inttotaladd & " Skip:" & inttotalskip)
End Sub
