Attribute VB_Name = "Main"
Option Explicit
'-------------------------------------------------------------------------
' global.bas  -  Globale Einstellungen und Routinen
'-------------------------------------------------------------------------

Const max_severity = 3         ' Einstellung, wie genau protokolliert wird  0 = info 1=Err, 2=Wrn 3+ = debug
'Const glogfilename = "c:\fpvba.log"   'Pfad fr Protokolldatei
Const ForReading = 1
Const ForWriting = 2
Const ForAppending = 8

' Globale Variablen
Public gbaseURL, glogfilename
Public ggooglemapgsitemapfile, ggooglemapns
Public glogbuchID, glogbuchfile, glogbuchsource, glogbuchentries
Public grssinput, grssoutput, grsstemplate, grssmaxitems
Public gpageworkTitleprefix
Public gsitemapID, gsitemapfile
Public arrkeywords()

Sub start()
    Dim arrkeywords(2, 1)  ' 3 mal  x
    Call loadconfig
    FRM_MSXFAQ.Show
End Sub

Sub loadconfig()
    Dim configfile, Result
    Dim ConfigXML As MSXML2.DOMDocument
    Set ConfigXML = New MSXML2.DOMDocument
    ConfigXML.async = False
    ConfigXML.validateOnParse = True
    configfile = Replace(Mid(ActiveWeb.url, 9) & "/config.xml", "/", "\")
    If ConfigXML.load(configfile) Then
        glogfilename = ConfigXML.selectSingleNode("//config/logfile").Text
        gbaseURL = ConfigXML.selectSingleNode("//config/baseurl").Text
        ggooglemapgsitemapfile = ConfigXML.selectSingleNode("//config/googlemap/sitemapfile").Text
        ggooglemapns = ConfigXML.selectSingleNode("//config/googlemap/ns").Text
        glogbuchID = ConfigXML.selectSingleNode("//config/logbuch/id").Text
        glogbuchfile = ConfigXML.selectSingleNode("//config/logbuch/file").Text
        glogbuchsource = ConfigXML.selectSingleNode("//config/logbuch/source").Text
        glogbuchentries = ConfigXML.selectSingleNode("//config/logbuch/entries").Text
        grssinput = ConfigXML.selectSingleNode("//config/rss/input").Text
        grssoutput = ConfigXML.selectSingleNode("//config/rss/output").Text
        grsstemplate = ConfigXML.selectSingleNode("//config/rss/template").Text
        grssmaxitems = ConfigXML.selectSingleNode("//config/rss/maxitems").Text
        gpageworkTitleprefix = ConfigXML.selectSingleNode("//config/pagework/titleprefix").Text
        gsitemapID = ConfigXML.selectSingleNode("//config/sitemap/id").Text
        gsitemapfile = ConfigXML.selectSingleNode("//config/sitemap/filename").Text
    Else
        MsgBox "Error loading config file"
    End If
End Sub



' Sub RunAll()  ' nun im Form enthalten
'    Call Logging(0, "RUNALL:  gestartet")
'    Call menubreadcrumb.menubreadcrumb
'    Call SiteMap.SiteMap
'    Call RSS.MakeRSS
'    Call TGMenu.TGMenu
'    Call Logging(0, "RUNALL:  beendet")
'End Sub

Sub Logging(severity As Integer, Message As String)
' Globale Funktion zur Ausgabe der Statusmeldungen in einer textbox und dem Debug feld
' Programm Konstanten und Variablen
' Sinnvoll ist der Aufruf mit logging ([1-5]},"Programm/Prozedur: schritt bzw Information"

    Dim fso, logfile, strSeverity

    If severity <= max_severity Then
        Select Case severity
            Case 0: strSeverity = "INFO"
            Case 1: strSeverity = "ERR"
            Case 2: strSeverity = "WRN"
            Case Else: strSeverity = "DBG" & CStr(severity)
        End Select
        
        If FRM_MSXFAQ.Visible = True Then
            FRM_MSXFAQ.Result.Text = FRM_MSXFAQ.Result.Text & vbCrLf & Str(Now) + ":" + CStr(strSeverity) + ":" + Message
            DoEvents
            FRM_MSXFAQ.Result.SetFocus
        End If

        ' Debug.Print Str(Now) + "," + CStr(strSeverity) + ":" + Message
        Set fso = CreateObject("Scripting.FileSystemObject")
        ' Set logfile = fso.CreateTextfile(glogfilename, ForWriting)  'Create/overwrite menu file
        Set logfile = fso.OpenTextFile(glogfilename, ForAppending, True)
        logfile.write Str(Now) + "," + CStr(strSeverity) + ":" + Message & vbCrLf
        logfile.Close
    End If
End Sub

Sub abbruch(info)
    If MsgBox(info & " Continue ?", vbYesNo, "Stop Process ?") <> 6 Then
        Call Logging(0, "ABBRUCH:Abbruch durch Anwender")
        Application.Quit
    End If
End Sub

Function Umlaut(Strsource As String) As String
    Strsource = Replace(Strsource, " ", "&nbsp;") '   erzwungenes Leerzeichen &nbsp;
    Strsource = Replace(Strsource, "", "&auml;") '  A-Umlaut &Auml;
    Strsource = Replace(Strsource, "", "&ouml;") '  o-Umlaut
    Strsource = Replace(Strsource, "", "&uuml;") '  u-Umlaut ;
    Strsource = Replace(Strsource, "", "&Auml;")
    Strsource = Replace(Strsource, "", "&Ouml;") '  o-Umlaut &Ouml;
    Strsource = Replace(Strsource, "", "&Uuml;") '  U-Umlaut
    Strsource = Replace(Strsource, "", "&szlig;") '  scharfes S
    Strsource = Replace(Strsource, "", "a")
    Strsource = Replace(Strsource, "", "a")
    Strsource = Replace(Strsource, "", "a")
    Strsource = Replace(Strsource, "", "e")
    Strsource = Replace(Strsource, "", "e") ' Umsetzen der Umlaute
    Strsource = Replace(Strsource, "", "e")
    Strsource = Replace(Strsource, "", "i")
    Strsource = Replace(Strsource, "", "i")
    Strsource = Replace(Strsource, "", "i")
    Strsource = Replace(Strsource, "", "o")
    Strsource = Replace(Strsource, "", "o")
    Strsource = Replace(Strsource, "", "o")
    Strsource = Replace(Strsource, "", "u")
    Strsource = Replace(Strsource, "", "u")
    Strsource = Replace(Strsource, "", "u")
'  noch nicht eingebaut
' " Anfhrungszeichen &quot;
'  doppelte Anfhrungszeichen links &laquo;
'  doppelte Anfhrungzeichen rechts &raquo;
' < kleiner als &lt;
' > grer als &gt;
'  Copyright &copy;
'  registriertes Warenzeichent &reg;
'  Pfund-Zeichen &pound;
'  Paragraph-Zeichen &sect;
'  Grad-Zeichen &deg;
'  ein Viertel &frac14;
'  ein Halb &frac12;
'  drei Viertel &frac34;
'  Hoch-2-Zeichen &sup2;
'  Hoch-3-Zeichen &sup3;
    Umlaut = Strsource
End Function

Public Function IsHTMLFile(ByVal filename As String) As Boolean
IsHTMLFile = ( _
  LCase(Right(filename, 4)) = "html" Or _
  LCase(Right(filename, 3)) = "htm" Or _
  LCase(Right(filename, 3)) = "asp")
End Function

Public Function IsExternalLink(ByVal Href As String) As Boolean
IsExternalLink = ( _
  Left(Href, 7) = "http://" Or _
  Left(Href, 8) = "https://" Or _
  Left(Href, 6) = "ftp://" Or _
  Left(Href, 5) = "news:")
End Function

Function TrimmedStringsMatch(ByVal s1 As String, ByVal s2 As String) As Boolean
'Testet, ob zwei Strings identisch sind, wenn Leerraumzeichen nicht bercksichtigt werden.

    s1 = RemoveWhitespace(s1)
    s2 = RemoveWhitespace(s2)
    
    If StrComp(s1, s2, vbTextCompare) = 0 Then
        TrimmedStringsMatch = True
    Else
        TrimmedStringsMatch = False
    End If
    
End Function
    
Function RemoveWhitespace(ByVal s As String) As String
'Entfernt Leerraumzeichen aus Strings.

    s = Replace(s, " ", "")
    s = Replace(s, vbCr, "")
    s = Replace(s, vbLf, "")
    s = Replace(s, vbTab, "")
    RemoveWhitespace = s
End Function

    
Function HTMLEncode(ByVal s As String) As String
'Verndert einen String so, da er gefahrlos in Attributwerten oder Elementinhalt verwendet werden kann.

    s = Replace(s, "&", "&amp;")
    s = Replace(s, "<", "&lt;")
    s = Replace(s, ">", "&gt;")
    s = Replace(s, """", "&quot;")
    s = Replace(s, "'", "&#39;") 'Fr den Apostroph gibt es in HTML keine Entity.
    HTMLEncode = s
End Function
    

