Attribute VB_Name = "Sitemap"
Option Explicit
' Frontpage VBA Macro to create a Sitemap
' (c) 2005 Frank Carius  http://www.msxfaq.de
' Sitemap Site muss Tag enthalten <div id="Sitemap"></div>

Sub SiteMap()

'    Const gsitemapID As String = "Sitemap"
'    Const gsitemapfile As String = "sonst/sitemap.htm"       ' name of the item definition file in the current web
    
    Dim sitemapfile As WebFile
    Dim pw As PageWindowEx
    Dim elm As IHTMLElement
    Dim smap As String

    If ActiveWeb Is Nothing Then
        MsgBox "Sie mssen zuerst ein Web ffnen.", vbOKOnly Or vbCritical
        Exit Sub
    End If
    Call Logging(0, "BuildSitemap: gestartet")
    Set sitemapfile = ActiveWeb.LocateFile(gsitemapfile)
    Set pw = sitemapfile.Edit(fpPageViewNoWindow)
    
    Call Logging(0, "BuildSitemap: file geladen")

    If pw.Document.body.all.Item(gsitemapID) Is Nothing Then
      MsgBox "Es gibt kein Element mit der ID '" & gsitemapID & "'.", vbOKOnly Or vbCritical
      Call Logging(0, "BuildSitemap: gsitemapfile invalid - ID nicht gefunden")
      Exit Sub
    End If
   
    Set elm = pw.Document.body.all.Item(gsitemapID)
    smap = elm.innerHTML                        ' Alte Version merken
    elm.innerHTML = BuildSubSitemap(ActiveWeb.RootNavigationNode, 0)
    Call Logging(0, "BuildSitemap: Sitemap generiert")
    If smap <> elm.innerHTML Then               'Nur speichern wenn gender
        sitemapfile.Edit.Save
        Call Logging(0, "BuildSitemap: Sitemap geaendert und gespeichert")
    End If
    sitemapfile.Edit.Close
    
    Call Logging(0, "BuildSitemap: beendet")
End Sub

Function BuildSubSitemap(ByRef node As NavigationNode, level As Integer) As String
  
    Dim childNode As NavigationNode
    Dim ProcessChild As Boolean
   
    BuildSubSitemap = ""
    If node Is ActiveWeb.RootNavigationNode Then    'es ist die Wurzel
        ProcessChild = True ' Wurzel nicht ausgeben aber Untereintrge bearbeiten
    Else
        If node.InNavBars = True Then
            Dim relativeURL As String
            relativeURL = MakeRel(ActiveWeb.url + "/", node.url)
            BuildSubSitemap = "<a href='../" & relativeURL & "'>" & node.Label & "</a>"
            ProcessChild = True  'Untereintrge bearbeiten
        Else
            ProcessChild = False  'Untereintrge ignorieren
        End If
    End If
    
    If ProcessChild And (node.Children.count > 0) Then
        BuildSubSitemap = BuildSubSitemap & "<ul>"
        For Each childNode In node.Children
            Dim subsite As String
            subsite = BuildSubSitemap(childNode, level + 1)
'            subsite = Replace(subsite, "<ul>", "", vbTextCompare)  'Listentags entfernen
'            subsite = Replace(subsite, "<li>", "", vbTextCompare)
'            subsite = Replace(subsite, "</li>", "", vbTextCompare)
'            subsite = Replace(subsite, "</ul>", "", vbTextCompare)
            If subsite <> "" Then               ' mindestens eine Childseite ist sichtbar
                BuildSubSitemap = BuildSubSitemap & "<li>" & BuildSubSitemap(childNode, level + 1) & "</li>"
            End If
        Next
        BuildSubSitemap = BuildSubSitemap & "</ul>"
    End If
  
End Function
