Attribute VB_Name = "TGMenu"
Option Explicit
' Frontpage VBA Macro to create a menu definition file for TigraMenu v2.0
' see http://www.softcomplex.com/products/tigra_menu/
' (c) 2005 Frank Carius  http://www.msxfaq.de

Const OUTPUT_FILE As String = "menu_items.js"       ' name of the item definition file in the current web

'Const menuiconhtm = "<img border=""0"" src=""/images/icon-menuhtm.gif"" align=""middle"">"
'Const menuiconfld = "<img border=""0"" src=""/images/icon-menufld.gif"" align=""middle"">"
Const menuiconhtm = ""
Const menuiconfld = ""

Sub TGMenu()
    'Main procedure to build the tigra menu based on the fronpage navigation structure

    Call Logging(0, "BuildTGMenu: gestartet")
    If ActiveWeb Is Nothing Then
            Call Logging(4, "BuildTGMenu: FEHLER: Kein Web geffnet")
            MsgBox "Please open a web first to build the menu file !", vbOKOnly Or vbCritical
            Exit Sub
    End If
    Open ActiveWeb.RootFolder.Name + "\" + OUTPUT_FILE For Output As #1
    Print #1, "var MENU_ITEMS = ["
    Print #1, BuildTGSubMenu(ActiveWeb.RootNavigationNode, 0)
    Print #1, "];"
    Close #1
    Call Logging(0, "BuildTGMenu: beendet")
End Sub

Function BuildTGSubMenu(ByRef node As NavigationNode, level As Integer) As String

    Dim childNode As NavigationNode
    If node Is ActiveWeb.RootNavigationNode Then  ' handle special case rootnode
        For Each childNode In node.Children
            BuildTGSubMenu = BuildTGSubMenu & BuildTGSubMenu(childNode, level + 1)          ' process child navigation nodes
        Next
    Else
        If node.InNavBars Then                          ' ignore excluded pages
            Call Logging(2, "BuildTGMenu: Verarbeite:" + MakeRel(ActiveWeb, node.url))
            If node.Children.count = 0 Then
                BuildTGSubMenu = Space(level * 4) + "['" + menuiconhtm + HTMLUmlaut(node.Label) + "','/" & MakeRel(ActiveWeb, node.url) + "',null"
                BuildTGSubMenu = BuildTGSubMenu + "]," + vbCrLf                              ' close submenu
            Else
                BuildTGSubMenu = Space(level * 4) + "['" + menuiconfld + HTMLUmlaut(node.Label) + "->','/" & MakeRel(ActiveWeb, node.url) + "',null"
                BuildTGSubMenu = BuildTGSubMenu + "," + vbCrLf                               ' close line partially
                For Each childNode In node.Children
                    BuildTGSubMenu = BuildTGSubMenu & BuildTGSubMenu(childNode, level + 1)          ' process child navigation nodes
                Next
                BuildTGSubMenu = BuildTGSubMenu & Space(level * 4) + "]," + vbCrLf              ' close parent menu if not top level menu
            End If
        End If
    End If
End Function


